- Qt 5.3
- Qt Quick
- C++ Classes
- QQuickFramebufferObject
- Qt 5.3.2 Reference Documentation

# QQuickFramebufferObject Class

The QQuickFramebufferObject class is a convenience class for integrating OpenGL rendering using a framebuffer object (FBO) with Qt Quick. More...

Header: | `#include <QQuickFramebufferObject>`
qmake: | `QT += quick`
Since: | Qt 5.2
Inherits: | QQuickItem.

- List of all members, including inherited members

## Public Types

class | Renderer

## Properties

- textureFollowsItemSize : bool

- 23 properties inherited from QQuickItem

## Public Functions

| QQuickFramebufferObject(QQuickItem * parent = 0)
virtual Renderer * | createRenderer() const = 0
void | setTextureFollowsItemSize(bool follows)
bool | textureFollowsItemSize() const

- 91 public functions inherited from QQuickItem

## Signals

void | textureFollowsItemSizeChanged(bool)

- 1 signal inherited from QQuickItem

### Additional Inherited Members

- 1 public slot inherited from QQuickItem
- 33 protected functions inherited from QQuickItem

## Detailed Description

The QQuickFramebufferObject class is a convenience class for integrating OpenGL rendering using a framebuffer object (FBO) with Qt Quick.

On most platforms, the rendering will occur on a dedicated thread. For this reason, the QQuickFramebufferObject class enforces a strict separation between the item implementation and the FBO rendering. All item logic, such as properties and UI-related helper functions needed by QML should be located in a QQuickFramebufferObject class subclass. Everything that relates to rendering must be located in the QQuickFramebufferObject::Renderer class.

To avoid race conditions and read/write issues from two threads it is important that the renderer and the item never read or write shared variables. Communication between the item and the renderer should primarily happen via the QQuickFramebufferObject::Renderer::synchronize() function. This function will be called on the render thread while the GUI thread is blocked.

Using queued connections or events for communication between item and renderer is also possible.

Both the Renderer and the FBO are memory managed internally.

To render into the FBO, the user should subclass the Renderer class and reimplement its Renderer::render() function. The Renderer subclass is returned from createRenderer().

The size of the FBO will by default adapt to the size of the item. If a fixed size is preferred, set textureFollowsItemSize to `false` and return a texture of your choosing from QQuickFramebufferObject::Renderer::createFramebufferObject().

See also Scene Graph - Rendering FBOs and Scene Graph and Rendering.

## Property Documentation

### textureFollowsItemSize : bool

This property controls if the size of the FBO's texture should follow the dimensions of the QQuickFramebufferObject item. When this property is false, the FBO will be created once the first time it is displayed. If it is set to true, the FBO will be recreated every time the dimensions of the item change.

The default value is `true`.

Access functions:

bool | textureFollowsItemSize() const
void | setTextureFollowsItemSize(bool follows)

Notifier signal:

void | textureFollowsItemSizeChanged(bool)

## Member Function Documentation

### QQuickFramebufferObject::QQuickFramebufferObject(QQuickItem * parent = 0)

Constructs a new QQuickFramebufferObject with parent parent.

### Renderer * QQuickFramebufferObject::createRenderer() const`[pure virtual]`

Reimplement this function to create a renderer used to render into the FBO.

This function will be called on the rendering thread while the GUI thread is blocked.